%global apiver  20100412
%global zendver 20100525
%global pdover  20080721

%define phplib %{_libdir}/php
%define extdir %{phplib}/extensions
%define peardir %{_datadir}/php/pear
%define phpvar  /var/lib/php

%define allow_exec_dir 1
%define _unpackaged_files_terminate_build 0

# don't build debug package
%define debug_package %{nil}
# don't binary strip
#define __spec_install_post %{nil}

%define build_fpm 1

%{!?_with_no_goto:%define _vm_goto 1}
%{?_with_no_goto:%define _vm_goto 0}

Summary: The PHP HTML-embedded scripting language for use with Apache2.
Summary(ko): Apache2 PHP 엔진
Name: php
Version: 5.4.12
Release: 1%{?dist}
Epoch: 10
Group: Development/Languages
License: PHP
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source2: info.php
Source3: macros.php
Source4: php-dependency.txt

Source100: pecl-extension.tar.bz2
Source101: httpd.conf
Source102: annyung_func_alias_table.php

# patch start
# oops patch to 1 - 99
Patch1: php-ini.patch
Patch2: php-version.patch
Patch3: php-libtool2.patch
Patch4: php-5.4.12-fpm-logpath.patch

# extension patch
Patch20: php-mysql.patch
Patch21: php-mysql-charset.patch
Patch22: php-gd-charspace.patch
Patch23: php-libgd-freetype.patch
Patch24: php-annyung-exec-dir.patch
Patch26: php-dba.patch
Patch27: php-snmp-shutdown.patch
Patch29: php-phpize64.patch
Patch30: php-includedir.patch
Patch31: php-tmpdir.patch
Patch32: php-annyung-alias.patch
Patch33: php-annyung-zend-listed-table.patch
# Patch 34 and Patch 35 are dependent on patch 33
Patch34: php-annyung-include-file-check.patch
# Patch 35 is dependent on Patch 34
Patch35: php-annyung-image-attack.patch
# block '\0' to path after 5.3.4RC1. still need?
Patch36: php-annyung-urldecode-hex-null.patch
Patch37: php-annyung-realpath-cache-force.patch

# patch for rhel5
Patch100: php-4.3.1-odbc.patch
Patch101: php-fc-dlopen.patch
Patch103: php-5.3.18-gnusrc.patch
Patch104: php-5.3.18-systzdata-v7.patch
Patch105: php-5.3.18-embed.patch

# patch third party extension
Patch201: php-libevent-1.4.patch
Patch202: php-sqlite-php54.patch
Patch203: php-sqlite-config.patch

# private patch
# http://wiki.ohgaki.net/index.php?PHP%2Fpatch
Patch3000: php-allow_url_fopen-INI_ALL.patch

# offcial patch
Patch5000: php-5.4.12-official-b64124.patch
Patch5001: php-5.4.12-official-b64106.patch
Patch5002: php-5.4.12-official-b60840.patch
Patch5003: php-5.4.12-official-b61930.patch
Patch5004: php-5.4.12-official-b63530.patch
Patch5005: php-5.4.12-official-mp_split-enhanced.patch
Patch5006: php-5.4.12-official-b64128.patch
Patch5007: php-5.4.12-official-b64175.patch
Patch5008: php-5.4.12-official-b64142.patch
Patch5009: php-5.4.12-official-b64354.patch
Patch5010: php-5.4.12-official-b64197.patch
Patch5011: php-5.4.12-official-b64070.patch
Patch5012: php-5.4.12-official-b64235.patch

Patch9000: php-5.3.1-unofficial-bug-51056-fread.patch

# security


# patch end
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: webserver, php-common, libicu, bzip2-libs
Requires: openssl, zlib
BuildRequires: readline-devel, ncurses-devel, zlib-devel, file >= 4
BuildRequires: libpng-devel, libjpeg-devel, db4-devel, gdbm-devel
#BuildRequires: openssl-devel, zlib-devel, libxml2-devel, mysql-devel
BuildRequires: openssl-devel, zlib-devel, libxml2-devel bison
BuildRequires: curl-devel, freetds-devel, freetype-devel
BuildRequires: libmcrypt-devel, mhash-devel, libicu-devel
BuildRequires: libevent-devel >= 1.4, net-snmp-devel sqlite-devel
BuildRequires: httpd-devel, sendmail, openldap-devel bzip2-devel
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

Building option:
	--with no_goto : if don't add vm kind option with goto..

%package cli
Group: Development/Languages
Summary: php command line interface
Summary(ko): php cli 인터페이스
Requires: php-common, readline, ncurses, zlib, openssl, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description cli
php binary file to use in shell

%package fpm
Group: Development/Languages
Summary: php5 fpm engine
Requires: php-fpm-conf, zlib, openssl, libicu, ncurses, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description fpm
php fastcgi(fpm) server api

%package devel
Group: Development/Libraries
Summary: php development file for making extensions
Summary: php 확장 개발을 위한 파일들

%description devel
php build file for making extensions

%package extension
Group: Development/Languages
Summary: php shared extension
Requires: phpapi
Requires: libjpeg, db4, gdbm, file, curl, openldap
#Requires: sqlite, mysql-shared, freetype, freetds, libpng, libmcrypt, mhash
Requires: sqlite, freetype, freetds, libpng, libmcrypt, mhash
Requires: libicu, libevent >= 1.4, net-snmp-libs
# block centos' php
Obsoletes: php-bcmath php-dba php-gd php-imap php-ldap php-odbc
Obsoletes: php-mysql php-pecl-apc php-pecl-memcache php-pgsql
Obsoletes: php-recode php-snmp php-soap php-tidy php-xml

%description extension
This package include php shared extension

%prep
%setup -q -n php-%{version} -a 100

pushd $RPM_BUILD_DIR/php-%{version} &> /dev/null
tar xvfpj %{SOURCE100}
popd &> /dev/null

# official patch
%patch5000 -p1
%patch5001 -p1
%patch5002 -p1
%patch5003 -p1
%patch5004 -p1
%patch5005 -p1
%patch5006 -p1
%patch5007 -p1
%patch5008 -p1
%patch5009 -p1
%patch5010 -p1
%patch5011 -p1
%patch5012 -p1

%patch9000 -p1

# sec

%patch1 -p1
%patch2 -p1
%patch3 -p1
%if %{build_fpm}
%patch4 -p1
%endif

%patch20 -p1
#patch21 -p1
%patch22 -p1
%patch23 -p1
%if %{allow_exec_dir}
%patch24 -p1
%endif
%patch26 -p1
#patch27 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
#patch36 -p1
%patch37 -p1

# fedora patch
%patch100 -p1
%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# private update
%patch3000 -p1

#patch201 -p0
%patch202 -p0
%patch203 -p1


%if %{_vm_goto}
pushd Zend
	# php 5.3 support --with-zend-vm=GOTO. is applicated readly?
	if [ -f "/usr/bin/php" ]; then
		%{__rm} -f zend_vm_execute.h
		php zend_vm_gen.php --with-vm-kind=GOTO
	fi
popd
%endif

%build

BuildPHP() {
	[ ! -d "%{phpvar}/tmp" ] && mkdir -p %{phpvar}/tmp && chmod 1777 %{phpvar}/tmp
	#OOPS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing -Wno-pointer-sign"
	RPMS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"
	export CFLAGS="-fPIC ${RPMS_FLAGS}"
	export EXTENSION_DIR=%{extdir}
	export PEAR_INSTALLDIR=%{peardir}

	case "$1" in
		cli) scandir="cli"; shift ;;
		apache) scandir="apache"; shift ;;
		fpm) scandir="fpm"; shift ;;
	esac

#		--without-pic \
	%{configure} \
		--with-libdir=%{_lib} \
		--sysconfdir=%{_sysconfdir}/php.d \
		--with-config-file-path=%{_sysconfdir}/php.d \
		--with-config-file-scan-dir=%{_sysconfdir}/php.d/$scandir \
		--disable-debug \
		--disable-xmlreader \
		--disable-xmlwriter \
		--disable-json \
		--without-pear \
		--without-sqlite \
		--without-sqlite3 \
		--with-regex=php \
		--with-bz2 \
		--with-zlib \
		--with-zlib-dir=%{_prefix} \
		--enable-mod-charset \
		--enable-zend-signals \
		--enable-sigchild \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-sysvmsg \
		--enable-intl \
		--enable-soap=shared \
		--enable-pdo \
		--without-pdo-sqlite \
		--without-pdo-mysql \
		--enable-sockets \
		--enable-mbstring=all \
		--enable-mbregex \
		--enable-mbregex-backtrack \
		--with-libmbfl \
		--with-iconv \
		--with-openssl \
		--with-xmlrpc \
		--with-mysql=shared,mysqlnd \
		--with-system-tzdata \
		$*

	%{__make} %{?_smp_mflags}
}

%{__rm} -f configure

# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4

# pull latest ltmain.sh, AC_PROG_LIBTOOL
# Force use of system libtool:
libtoolize --force --copy
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
# force aclocal run during buildconf
touch acinclude.m4

./buildconf --force

# binary compile
BuildPHP cli \
		--with-exec-dir="" \
		--enable-pcntl \
		--with-readline \
		--with-ncurses \
		--disable-cgi \
		--enable-static

mv sapi/cli/php sapi/cli/php-cli
%{__mkdir_p} %{buildroot}%{_bindir}
mv ext/phar/phar.phar ext/phar/phar.phar.cli

# build fastcgi module
%{__make} clean

%if %{build_fpm}
BuildPHP fpm \
		--with-exec-dir=%{phpvar}/bin \
		--enable-fpm \
		--disable-cli \
		--enable-pcntl \
		--with-ncurses

mv sapi/fpm/php-fpm sapi/fpm/php-fpm-back

# build apache module
%{__make} clean
%endif

BuildPHP apache \
		--with-apxs2=/usr/sbin/apxs \
		--with-exec-dir=%{phpvar}/bin \
		--disable-cli \
		--disable-cgi \
		--with-curl=shared,%{_prefix} \
		--with-gd=shared \
		--enable-gd-native-ttf \
		--with-jpeg-dir=%{_prefix} \
		--with-png-dir=%{_prefix} \
		--with-freetype-dir=%{_prefix} \
		--enable-bcmath=shared \
		--enable-calendar=shared \
		--enable-memcache=shared \
		--enable-xmlreader=shared, --enable-xmlwriter=shared \
		--enable-ftp=shared \
		--enable-dba=shared \
		--enable-exif=shared \
		--with-gdbm \
		--with-dbm \
		--with-db4 \
		--enable-fileinfo=shared \
		--with-gettext=shared \
		--with-mcrypt=shared \
		--with-sqlite3=shared \
		--with-sqlite=shared --enable-sqlite-utf8 \
		--with-ldap=shared --with-ldap-sasl \
		--with-snmp=shared,%{_prefix} \
		--with-libevent=shared \
		--with-pdo-sqlite=shared,%{_prefix} \
		--with-pdo-mysql=shared,mysqlnd \
		--with-mysqli=shared,mysqlnd \
		--with-mssql=shared \
		--enable-json=shared

cd modules
/bin/ls *.so | sed 's/^/;extension = /' > ../extensions.ini
cd -

%install
[ "%{buildroot}" != "/" -a -d "${buildroot}" ] && rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf
install -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

%{__make} install INSTALL_ROOT=%{buildroot} INSTALL_ID="echo "

rm -rf %{buildroot}%{extdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{extdir}
mkdir -p %{buildroot}/home/httpd/html
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_sysconfdir}/php.d/{cli,apache}

install -m 755 ext/phar/phar.phar.cli %{buildroot}%{_bindir}/phar.phar
cd %{buildroot}%{_bindir}
ln -sf phar.phar phar
cd -

install -m 755 sapi/cli/php-cli %{buildroot}%{_bindir}/php
install -m 644 sapi/cli/php.1 %{buildroot}%{_mandir}/man1/php.1
#(cd %{buildroot}%{_bindir}; ln -sf php php5)
install -m 755 -s modules/*.so %{buildroot}%{extdir}
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php.ini
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php-cli.ini
install -m 644 %{SOURCE2} %{buildroot}/home/httpd/html/php_info.php

install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/apache/shared.ini
install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/cli/shared.ini


%if %{build_fpm}
%{__mkdir_p} %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_mandir}/man8
install -m 755 sapi/fpm/php-fpm-back %{buildroot}%{_sbindir}/php-fpm
install -m 644 sapi/fpm/php-fpm.8  %{buildroot}%{_mandir}/man8/php-fpm.8
%endif

%{__mkdir_p} %{buildroot}%{peardir}
install -m 644 %{SOURCE102} %{buildroot}/%{peardir}/alias_table.php

mv LICENSE LICENSE.php5

# session and update tmp dir
mkdir -p %{buildroot}%{phpvar}/{sessions,tmp,bin}

# dependency problem
pushd %{buildroot}%{phplib}/build
	chmod 644 *
	chmod 755 shtool
popd

# Generate files lists and stub .ini files for each subpackage
for mod in $(ls %{buildroot}%{extdir}/*.so)
do
	modname=$(basename $mod | sed 's/\.so//g')
	cat >> files.ext <<EOF
%attr(755,root,root) %{extdir}/${modname}.so
EOF
done

# Package pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.pdo_sqlite >> files.pdo

# Install the macros file:
install -d %{buildroot}%{_sysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}/;s/@PHP_ZENDVER@/%{zendver}/;s/@PHP_PDOVER@/%{pdover}/" \
    < $RPM_SOURCE_DIR/macros.php > macros.php
install -m 644 -c macros.php \
           %{buildroot}%{_sysconfdir}/rpm/macros.php

# Remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf \
       %{buildroot}%{_bindir}/{phptar} \
       %{buildroot}%{_datadir}/pear

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
rm -f files.* macros.php

%files
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/httpd/modules/libphp5.so
#{peardir}/alias_table.php
%dir %{phplib}
%dir %{phplib}/extensions
%attr(755,nobody,nobody) %dir %{phpvar}/sessions
%attr(1777,root,root) %dir %{phpvar}/tmp
%attr(755,root,root) %dir %{phpvar}/bin

%files cli
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/php
%attr(755,root,root) %{_bindir}/phar.phar
%{_bindir}/phar
%{_mandir}/man1/php.1*
#{_bindir}/php5

%if %{build_fpm}
%files fpm
%attr(755,root,root) %{_sbindir}/php-fpm
%{_mandir}/man8/php-fpm.8*
%endif

%files devel
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rpm/macros.php
%{_bindir}/php-config
%{_bindir}/phpize
%{_includedir}/php
%{_libdir}/php/build

%files extension -f files.ext

%changelog
* Thu Mar 14 2013 JoungKyun.Kim <http://oops.org> 10:5.4.12-1%{?dist}
- update 5.4.12
- add fpm server api
- Fixed bug #64124 (IPv6 malformed)
- Fixed bug #64106 (Segfault on SplFixedArray[][x] = y when extended)
- Fixed bug #60840 (undefined symbol: mysqlnd_debug_std_no_trace_funcs)
- Fixed bug #61930 (openssl corrupts ssl key resource when using
  openssl_get_publickey())
- New SSL stream context option to prevent CRIME attack vector.
- Fixed bug #63530 (mysqlnd_stmt::bind_one_parameter crashes, uses
  wrong alloc for stmt->param_bind).
- mb_split() can now handle empty matches like preg_split() does
- Fixed bug #64128 (buit-in web server is broken on ppc64)
- Fixed bug #64142 (dval to lval different behavior on ppc64)
- Fixed bug #64354 (Unserialize array of objects whose class can't
  be autoloaded fail)
- Implemented FR #64175 (Added HTTP codes as of RFC 6585)
- Fixed bug #64197 (_Offsetof() macro used but not defined on ARM/Clang)
- Fixed bug #64070 (Inheritance with Traits failed with error)
- Fixed bug #64235 (Insteadof not work for class method in 5.4.11)
- security issues
  . CVE-2013-1643
    The SOAP parser in PHP before 5.3.22 and 5.4.x before 5.4.13 allows
    remote attackers to read arbitrary files via a SOAP WSDL file
    containing an XML external entity declaration in conjunction with an
    entity reference, related to an XML External Entity (XXE) issue in the
    soap_xmlParseFile and soap_xmlParseMemory functions.
  . CVE-2013-1635
    ext/soap/soap.c in PHP before 5.3.22 and 5.4.x before 5.4.13 does not
    validate the relationship between the soap.wsdl_cache_dir directive
    and the open_basedir directive, which allows remote attackers to bypass
    intended access restrictions by triggering the creation of cached SOAP
    WSDL files in an arbitrary directory.

* Sat Dec 15 2012 JoungKyun.Kim <http://oops.org> 10:5.4.8-3%{?dist}
- Fixed bug #63235 (buffer overflow in use of SQLGetDiagRec).

* Thu Nov 15 2012 JoungKyun.Kim <http://oops.org> 1:5.4.8-2%{?dist}
- fixed missing #63399
- fixed bug #63241 PHP fails to open Windows deduplicated files.
- fixed bug #63447 max_input_vars doesn't filter variables when
  mbstring.encoding_translation = On
- set realpath_cache_force to enable, force enable realpath_cache_size
  and realpath_cache_ttl although safe_mode or open_basedir set enabled.

* Wed Oct 31 2012 JoungKyun.Kim <http://oops.org> 1:5.4.8-1%{?dist}
- update 5.4.8
- Fixed official bug
  Fixed bug #63297 (Phar fails to write an openssl based signature).
  Fixed bug #63284 (Upgrade PCRE to 8.31).
  Fixed bug #63055 (Segfault in zend_gc with SF2 testsuite).
  Fixed bug #63180 (Corruption of hash tables).
  Fixed bug #63265 (Add ORA-00028 to the PHP_OCI_HANDLE_ERROR macro)
  Fixed bug #63389 (Missing context check on libxml_set_streams_context() causes memleak).
  Fixed bug #63248 (Load multiple magic files from a directory under Windows).
  Fixed bug #63363 (Curl silently accepts boolean true for SSL_VERIFYHOST).
  Fixed bug #63369 ((un)serialize() leaves dangling pointers, causes crashes).
  Fixed bug #63305 (zend_mm_heap corrupted with traits). (Dmitry, Laruence)
  Fixed bug #62593 (Emulate prepares behave strangely with PARAM_BOOL).
  Fixed bug #63399 (ReflectionClass::getTraitAliases() incorrectly resolves traitnames).
- add sqlite (sqlite2) extension

